/*
 * CONTRAT DE LICENCE DE LOGICIEL LIBRE CeCILL-B
 * https://cecill.info/licences/Licence_CeCILL-B_V1-fr.html
 */
package fr.unistra.sil.erp.back;

import fr.unistra.sil.erp.back.db.DatabaseConnectionException;
import fr.unistra.sil.erp.back.db.DatabaseSQLiteImpl;
import fr.unistra.sil.erp.back.db.IDatabase;

/**
 * Manages the database implementation to use.
 * @author BEAUVAIS ANTOINE
 */
public class DatabaseSystem {
    
    /**
     * The database implementation object.
     */
    private static IDatabase instance;
    
    /**
     * Returns the database implementation in use.In order to change the 
     * implementation, simply change this method's implementation construction 
     * to the desired one.
     * 
     * @return the instance of the database implementation.
     * @throws DatabaseConnectionException if the connection to the DB failed.
     */
    public static IDatabase getInstance() throws DatabaseConnectionException
    {
        if(DatabaseSystem.instance == null)
            DatabaseSystem.instance = new DatabaseSQLiteImpl();
        
        if(DatabaseSystem.instance == null)
            throw new DatabaseConnectionException("Failed to create DB.");
        
        return DatabaseSystem.instance;
    }
}
